/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./wp-content/plugins/stellar/source/js/includes/_refresh.js":
/*!*******************************************************************!*\
  !*** ./wp-content/plugins/stellar/source/js/includes/_refresh.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   refreshStellar: () => (/* binding */ refreshStellar)
/* harmony export */ });
/* harmony import */ var _untils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./_untils */ "./wp-content/plugins/stellar/source/js/includes/_untils.js");


/**
 * Refresh the Stellar rating
 */
function refreshStellar() {

    const stellarWrappers = document.querySelectorAll( '.mdp-stellar-box' );
    stellarWrappers.forEach( ( $wrapper ) => {

        /** Get the ID of the wrapper */
        const id = (0,_untils__WEBPACK_IMPORTED_MODULE_0__.getId)( $wrapper );
        if ( ! id ) return;

        /** Check if the refresh is enabled */
        const refresh = $wrapper.getAttribute( 'data-refresh' ) ?? false;
        if ( JSON.parse( refresh ) === false ) return;

        updateRating(
            $wrapper,
            {
                stellarId: id,
                action: 'stellar_get_rating',
            }
        );

    } );

}

/**
 * GET request to the WordPress
 */
function updateRating( $wrapper, args ) {

    if ( args === undefined ) return;

    const { url, nonce } = window.mdpStellar;
    const requestUrl = `${ url }?nonce=${ nonce.getRating }&action=${ args.action ?? '' }&stellar_id=${ args.stellarId ?? '' }`;
    const xHttp = new XMLHttpRequest();

    xHttp.open( 'GET', requestUrl, true );
    xHttp.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded');
    xHttp.addEventListener( 'error', errorHandler );
    xHttp.addEventListener( 'abort', errorHandler );

    xHttp.onload = () => {

        if ( xHttp.status ) {

            /**
             * @param remote.votes
             * @returns {boolean}
             */
            const remote = JSON.parse( xHttp.response );

            if ( $wrapper.querySelector( `.mdp-stellar-results` ) && remote.rating ) {
                $wrapper.querySelector( `.mdp-stellar-results` ).innerHTML = remote.rating;
            }

            if (  $wrapper.querySelector( `.mdp-stellar-votes` ) && remote.votes  ) {
                $wrapper.querySelector( `.mdp-stellar-votes` ).innerHTML = remote.votes;
            }

        } else {

            errorStatus( xHttp );
            return false;

        }

    };

    xHttp.send();

}

/**
 * Error handler for the GET request
 * @param e
 */
function errorHandler( e ) {

    console.error( 'Stellar request error' );
    console.error( e );

}

/**
 * Error status for the GET request
 * @param response
 */
function errorStatus( response ) {

    if ( ! response.status ) {

        console.error( 'Get likes failed! See below:' );
        console.error( response );

    } else if ( response.status !== 200 ) {

        console.error( 'Get likes error! Returned status of ' + response.status );

    }

}


/***/ }),

/***/ "./wp-content/plugins/stellar/source/js/includes/_untils.js":
/*!******************************************************************!*\
  !*** ./wp-content/plugins/stellar/source/js/includes/_untils.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getId: () => (/* binding */ getId)
/* harmony export */ });
/**
 * Get the ID of the Stellar wrapper
 * @param $wrapper
 * @returns {*}
 */
function getId( $wrapper ) {

    return $wrapper.id ? $wrapper.id.replace( 'mdp-stellar-', '' ) : false;

}


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!*********************************************************!*\
  !*** ./wp-content/plugins/stellar/source/js/stellar.js ***!
  \*********************************************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _includes_refresh__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./includes/_refresh */ "./wp-content/plugins/stellar/source/js/includes/_refresh.js");
/**
 * Stellar
 * Stellar is star rating system helps you rate and like articles on a website and keep track of results.
 * Exclusively on https://1.envato.market/stellar
 *
 * @encoding        UTF-8
 * @version         2.2.5
 * @copyright       (C) 2018 - 2024 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license         Envato License https://1.envato.market/KYbje
 * @contributors    Nemirovskiy Vitaliy (nemirovskiyvitaliy@gmail.com), Dmitry Merkulov (dmitry@merkulov.design)
 * @support         help@merkulov.design
 **/



( function () {

    "use strict";

    document.addEventListener( "DOMContentLoaded", function() {


        //
        (0,_includes_refresh__WEBPACK_IMPORTED_MODULE_0__.refreshStellar)();



        /** If there is no Stellar on this page then exit. */
        if ( document.querySelectorAll( '.mdp-stellar-box' ).length < 1 ) { return; }

        /** Flag to identify users voting for the first time. */
        let fNew = [];

        /** Previous values of the user's stellar. */
        let stellarData = prepareStellarData();

        // noinspection JSUnresolvedVariable
        /** Data from WP: ajax url and timestamp of last reset. */
        let wpData = window.mdpStellar;

        /** Remove all stellarData if they was created before last reset. */
        // noinspection JSUnresolvedVariable
        if ( wpData.reset_timestamp !== undefined) {

            // noinspection JSUnresolvedVariable
            if ( stellarData.timestamp < wpData.reset_timestamp ) {

                /** Recreate stellarData, like for first visit. */
                stellarData = {};
                stellarData.guid = GetGUID(); // Mark User with GUID.
                stellarData.timestamp = Math.floor( Date.now() / 1000 );

                /** Remember stellarData in Local Storage. */
                window.localStorage.setItem( 'mdpLocalStellarData', JSON.stringify( stellarData ) );
                window.sessionStorage.setItem( 'mdpSessionStellarData', JSON.stringify( stellarData ) );
            }

        }

        /** Find all Stellar boxes */
        const stellarBox = document.querySelectorAll( '.mdp-stellar-box' );

        /** Get data from the Local Storage and Session Storage */
        let stellarDataLS = JSON.parse( window.localStorage.getItem( "mdpLocalStellarData" ) );
        let stellarDataSS = JSON.parse( window.sessionStorage.getItem( "mdpSessionStellarData" ) );

        /**
         * Pseudo GUID. We use unique user id to identify previously voted users.
         *
         * @returns {String}
         **/
        function GetGUID() {

            // noinspection SpellCheckingInspection
            return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {

                const r = Math.random() * 16 | 0, v = c === 'x' ? r : (r & 0x3 | 0x8); // jshint ignore:line
                return v.toString(16);

            } );

        }

        /**
         * Prepare stellarData object
         * @return {any}
         */
        function prepareStellarData() {

            /**  Read stellarData from Local Storage. */
            let mdpLocalStellarData = JSON.parse( window.localStorage.getItem( 'mdpLocalStellarData' ) );

            /** Set LocalStorage and SessionStorage */
            if ( mdpLocalStellarData === null ) {
                /** We generate a key once for the entire session. */
                mdpLocalStellarData = {};
                mdpLocalStellarData.guid = GetGUID();

                /** Remember stellarData in Local Storage. */
                window.localStorage.setItem('mdpLocalStellarData', JSON.stringify( mdpLocalStellarData ) );
                window.sessionStorage.setItem('mdpSessionStellarData', JSON.stringify( mdpLocalStellarData ) );
            }

            return mdpLocalStellarData;

        }

        /**
         * Hover handler for each <i> element
         *
         * @param event
         */
        function stellarHover( event ) {

            if ( event.target.closest( 'i' ) !== null ) {

                const targetI = event.target.closest( 'i' ); //eventAR
                const iconsBox = targetI.closest( '.mdp-box-icon' );
                const icons = iconsBox.getElementsByTagName( 'i' ); //eventLinks
                const count = targetI.getAttribute( 'data-id' );

                // Add active class for each <i> element
                if ( icons.length > 0 ) {
                    for( let i = 0; i < count; i++ ){
                        icons[ i ].classList.add( 'mdp-box-list-hover' );
                    }
                }

                // Add hover class for target <i>
                targetI.classList.remove( 'mdp-stellar-hover' );

                // Update the rating valuation if it exist on the page
                if ( iconsBox.querySelector( '.mdp-rating-res' ) !== null ) {
                    iconsBox.querySelector( '.mdp-rating-res' ).innerText = count;
                }

                // Add and place the rating valuation tooltip to the hovered element if exist
                if ( iconsBox.querySelector( '.mdp-stellar-tooltip' ) !== null ) {

                    const ratingTooltip = iconsBox.querySelector( '.mdp-stellar-tooltip' );
                    const targetRect = targetI.getBoundingClientRect();
                    const parentRect = iconsBox.getBoundingClientRect();

                    ratingTooltip.classList.add('mdp-stellar-tooltip-show');
                    ratingTooltip.style.bottom = targetRect.top - parentRect.top + targetRect.height + 16 + 4 + 'px';
                    ratingTooltip.style.left = targetRect.left - parentRect.left  + ( targetRect.width - ratingTooltip.getBoundingClientRect().width ) / 2 + 'px';

                }

            }

        }

        /**
         * Ending Rating Bar Interaction Handler
         * @param event - On mouseout event
         * @return {boolean}
         */
        function endInteraction( event ) {

            const leaveTo = event.toElement || event.relatedTarget;
            const target = event.target;

            // Set <i> to default state if interaction is ended
            if ( event.target.closest( 'i' ) !== null ) {
                const targetI = event.target.closest( 'i' ); //e.target;
                const iconsBox = targetI.closest( '.mdp-box-icon' );
                const icons = iconsBox.getElementsByTagName( 'i' );
                const count = targetI.getAttribute( 'data-id' );

                // Remove hover class for target <i>
                targetI.classList.remove( 'mdp-stellar-hover' );

                // Remove active class for each <i> element
                if ( icons.length > 0 ) {
                    for( let i = 0; i < icons.length; i++ ){
                        icons[ i ].classList.remove( 'mdp-box-list-hover' );
                    }
                }

                // Update the rating valuation if it exist on the page
                if ( iconsBox.querySelector( '.mdp-rating-res' ) !== null ) {

                    if ( iconsBox.querySelector( '.mdp-stellar-tooltip' ) !== null ) {
                        // Sets the rating valuation data = data-id of leaved icon for tooltip
                        iconsBox.querySelector( '.mdp-rating-res' ).innerText = count;
                    } else {
                        // Sets 0 in other cases
                        iconsBox.querySelector( '.mdp-rating-res' ).innerText = 0;
                    }

                }

            }

            // Hide tooltip is interaction is completely finished
            if ( leaveTo !== null ) { //Right click

                if ( leaveTo.querySelector( '.mdp-box-icon' ) !== null || target.classList.contains( 'mdp-stellar-tooltip' ) || target.tagName === 'SPAN' ) {

                    if ( document.querySelector( '.mdp-stellar-tooltip-show' ) !== null ) {
                        document.querySelector( '.mdp-stellar-tooltip-show' ).classList.remove('mdp-stellar-tooltip-show');
                    }

                }

            }

        }

        /**
         * Rating clicking handler
         * Add scalable bubbles effect for clicked <i>
         *
         * @param target - Click Event target
         */
        function ratingClickEffect( target ) {

            // Create bubble svg
            const clickBubbles = document.createElementNS("http://www.w3.org/2000/svg", 'svg');
            clickBubbles.classList.add( 'mdp-stellar-bubbles' );
            clickBubbles.innerHTML = '<g id="grp7" opacity="0" transform="translate(7 6)">\n    ' +
            '<circle class="oval1" cx="2" cy="6" r="6"/><circle class="oval2" cx="5" cy="2" r="6"/>\n' +
            '</g>\n<g id="grp6" opacity="0" transform="translate(0 28)">\n    ' +
            '<circle class="oval1" cx="2" cy="7" r="5"/><circle class="oval2" cx="3" cy="2" r="7"/>\n' +
            '</g>\n<g id="grp3" opacity="0" transform="translate(52 28)">\n    ' +
            '<circle class="oval2" cx="2" cy="7" r="6"/><circle class="oval1" cx="4" cy="2" r="6"/>\n' +
            '</g>\n<g id="grp2" opacity="0" transform="translate(44 6)">\n    ' +
            '<circle class="oval2" cx="5" cy="6" r="5"/><circle class="oval1" cx="2" cy="2" r="7"/>\n' +
            '</g>\n<g id="grp5" opacity="0" transform="translate(14 50)">\n    ' +
            '<circle class="oval1" cx="6" cy="5" r="6"/><circle class="oval2" cx="2" cy="2" r="6"/>\n' +
            '</g>\n<g id="grp4" opacity="0" transform="translate(35 50)">\n    ' +
            '<circle class="oval1" cx="6" cy="5" r="5"/><circle class="oval2" cx="2" cy="2" r="7"/>\n' +
            '</g>\n<g id="grp1" opacity="0" transform="translate(24 0)">\n    ' +
            '<circle class="oval1" cx="2" cy="6" r="5"/><circle class="oval2" cx="5" cy="2" r="7"/>\n' +
            '</g>';

            // Set scale for click effect
            if ( typeof getComputedStyle( target ) === 'object' ) {
                if ( getComputedStyle( target )['font-size'].length > 0 ) {
                    clickBubbles.style.top = '-' + (getComputedStyle( target ).paddingLeft.replace('px','') - 1) + 'px';
                    clickBubbles.style.transform = 'scale(' + target.offsetWidth / 60 + ')';
                }
            }

            // Append SVG bubble effects
            target.appendChild( clickBubbles );

            // Display click effects
            setTimeout( function () {
                target.classList.add( 'mdp-stellar-rated' );
                clickBubbles.classList.add( 'mdp-stellar-click' );
            }, 50 );

            // Remove click effects
            setTimeout( function () {
                target.classList.remove( 'mdp-stellar-rated' );
                clickBubbles.remove();
            }, 1000 );

        }

        /**
         * Create AJAX call
         *
         * @param {object} data
         * @return
         **/
        function stellarRequest(data) {

            /** AJAX call */
            const xhttp = new XMLHttpRequest();
            let stellarDataLS = JSON.parse( window.localStorage.getItem("mdpLocalStellarData") );

            xhttp.open('POST', wpData.url + '?action=process_stellar', true);
            xhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhttp.send(encodeURI('stellar_id=' + data.stellar_id + '&rating=' + data.rating  + '&length=' + data.length + '&guid=' + stellarDataLS.guid + '&new_stellar=' + data.new_stellar));

            xhttp.onload = function () {

                // Request failed
                if ( ! xhttp.status ) {

                    console.warn('Request failed! See below:');
                    console.error( data );

                }

                // Request error
                else if ( xhttp.status !== 200 ) {

                    console.error('Request error.  Returned status of ' + xhttp.status);

                }

                // Request success
                else if ( xhttp.status === 200 ) {

                    fNew[ `stellar${ data.stellar_id }` ] = 0;
                    let answer = JSON.parse( xhttp.response );

                    (0,_includes_refresh__WEBPACK_IMPORTED_MODULE_0__.refreshStellar)();

                    /** Message about the result of sending data. */
                    if ( answer.message !== undefined ) {
                        console.warn( answer.message );
                    }

                }

            };

        }

        /**
         * Request page rank
         * @param data
         */
        function stellarPageRating(data) {

            /** AJAX call */
            const xhttp = new XMLHttpRequest();
            xhttp.open('POST', wpData.url + '?action=stellar_page_rating', true);
            xhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhttp.send(encodeURI('page_rating=1'+ '&stellar_id=' + data.stellar_id ));

            xhttp.onload = function () {

                // Request failed
                if ( ! xhttp.status ) {
                    console.warn('Request failed! See below:');
                }

                // Request error
                else if ( xhttp.status !== 200 ) {
                    console.error('Request error.  Returned status of ' + xhttp.status);
                }

                // Request success
                else if ( xhttp.status === 200 ) {

                    let answer = JSON.parse( xhttp.response );

                    /** After first like, one time update counter. */
                    if ( document.getElementsByClassName( 'mdp-stellar-results' ).length > 0 ) {

                        const stellarResult = document.getElementsByClassName( 'mdp-stellar-results' );
                        for ( let i = 0; i < stellarResult.length; i++ ) {
                            stellarResult[ i ].innerText = answer.page_rating;
                        }

                    }

                }
            };
        }

        /**
         * We call the function when you click on the icon.
         * @param event
         */
        function stellarClick( event ) {

            if ( event.target.closest( 'i' ) !== null ) {

                const thisId = event.target.closest( 'div.mdp-stellar-box' ).id.replace( 'mdp-stellar-', '' );
                const targetI = event.target.closest('i'); //eventTarget
                const iconsBox = targetI.closest('.mdp-box-icon');
                const icons = iconsBox.getElementsByTagName('i');
                const rating = targetI.getAttribute('data-id');
                const maxRating = iconsBox.getAttribute('data-rating'); //count_rating

                // Send async request
                const data = {
                    'stellar_id': thisId,
                    'rating': rating,
                    'length': wpData.length,
                    'new_stellar': fNew[ `stellar${ thisId }` ] && fNew[ `stellar${ thisId }` ] === 0 ? 0 : 1
                };
                stellarRequest( data );

                // Request Page Rank
                setTimeout( () => { stellarPageRating(data); },200 );

                // Save data to local storage
                stellarData[ `rating_${ thisId }` ] = rating;
                stellarData.timestamp = Math.floor( Date.now() / 1000 );
                stellarData.best_rating = maxRating;
                window.localStorage.setItem( 'mdpLocalStellarData', JSON.stringify( stellarData ) );
                window.sessionStorage.setItem( 'mdpSessionStellarData', JSON.stringify( stellarData ) );

                // Remove and add mdp-stellar-active class for <i>.
                if ( icons.length > 0 ) {

                    // Remove old voting active class
                    for( let i = 0; i < icons.length; i++ ){
                        icons[ i ].classList.remove( 'mdp-stellar-active' );
                        icons[ i ].querySelector( 'div' ).style.width = '0';
                    }

                    // Add new voting active class
                    for( let i = 0; i < rating; i++ ){
                        icons[ i ].classList.add( 'mdp-stellar-active' );
                    }

                }

                // Update 'Your page rank' data
                iconsBox.parentNode.querySelector( '.mdp-stellar-your-rating span' ).innerHTML = rating;

                // Click effect
                ratingClickEffect( targetI );

                // Update the rating valuation if it exists on the page
                if ( iconsBox.querySelector( '.mdp-rating-res' ) !== null ) {
                    iconsBox.querySelector( '.mdp-rating-res' ).innerText = rating;
                }

            }

        }

        /**
         * Display results for already voted users.
         *
         * @param $wrapper - Stellar wrapper
         */
        function stellarResults( $wrapper ) {

            if ( JSON.parse( window.localStorage.getItem( "mdpLocalStellarData" ) ) === null ){ return; }

            let stellarDataLS = JSON.parse( window.localStorage.getItem( "mdpLocalStellarData" ) );
            const icons = $wrapper.getElementsByTagName('i');
            const maxRating = icons.length;
            const thisId = $wrapper.id.replace( 'mdp-stellar-', '' );
            let rating = 0;

            // Recalculate and determine the number of painted icons
            if ( stellarData[ `rating_${ thisId }` ] !== undefined ) {

                if ( maxRating === stellarDataLS.best_rating ) {
                    rating = stellarData[ `rating_${ thisId }` ];
                } else {
                    rating = Math.round(( stellarData[ `rating_${ thisId }` ] / stellarDataLS.best_rating ) * maxRating);
                }

            }

            // Set rating data-attribute to User rating of
            if ( rating !== 0 && $wrapper.getAttribute( 'data-secrecy' ) === 'off' ) {
                $wrapper.setAttribute( 'data-rating', rating );
            }

            // Fill the icons
            stellarRating( $wrapper );

            // Update the rating valuation if it exist on the page
            if ( $wrapper.querySelector( '.mdp-rating-res' ) !== null ) {
                $wrapper.querySelector( '.mdp-rating-res' ).innerText = rating;
            }


        }

        /**
         * Run all Stellar events
         *
         * @param $wrapper - Stellar wrapper container
         */
        function stellarEvents( $wrapper ) {

            const box = $wrapper.querySelector( '.mdp-box-icon' );

            /** UnBind and Bind the End of interaction with the icons bar */
            box.removeEventListener( 'mouseout', endInteraction );
            box.addEventListener( 'mouseout', endInteraction );

            /** Find all Stellar Icons in single Stellar Box */
            const stellarIcon = box.getElementsByTagName( 'i' );
            if ( stellarIcon.length > 0 ) {

                for( let i = 0; i < stellarIcon.length; i++ ) {

                    /** UnBind and Bind the hover event listener for each <i> */
                    stellarIcon[i].removeEventListener( 'mouseover', stellarHover );
                    stellarIcon[i].addEventListener( 'mouseover', stellarHover );

                    /** UnBind and Bind the click event listener for each <i> */
                    stellarIcon[i].removeEventListener( 'click', stellarClick );
                    stellarIcon[i].addEventListener( 'click', stellarClick );

                }

            }

        }

        /**
         * Display and hide message for unable voting
         *
         * @param event - Click event
         */
        function stellarMessage( event ) {

            const box = event.target.closest( '.mdp-box-icon' );
            const newMessage = document.createElement( 'span' );

            /** Add message */
            newMessage.classList.add( 'mdp-stellar-message' );
            newMessage.innerText = wpData.limitText;
            box.appendChild( newMessage );

            /** Hide message */
            setTimeout( function () {
                newMessage.remove();
            }, 2000 );

        }

        /**
         * Returns rating value in rounded format
         *
         * @param $wrapper - Stellar parent element
         * @return {number|*}
         */
        function getRoundRating( $wrapper ) {

            const round = $wrapper.getAttribute( 'data-round' );
            const rating = $wrapper.getAttribute( 'data-rating' );

            if ( 'up' === round ) { return Math.ceil( rating ); }
            if ( 'no' === round ) { return rating; }
            if ( 'down' === round ) { return Math.floor( rating ); }

        }

        /**
         * Fill the icons
         *
         * @param $wrapper - Stellar parent element
         */
        function stellarRating( $wrapper ) {

            if ( $wrapper.getElementsByTagName( 'i' ).length < 1 ) { return; }

            const secrecy = $wrapper.getAttribute( 'data-secrecy' ) !== 'on'; // true = hide voting results
            const thisId = $wrapper.id.replace( 'mdp-stellar-', '' );
            const voted = stellarData[ `rating_${ thisId }` ] !== undefined;

            const icons = $wrapper.getElementsByTagName( 'i' );
            for( let i = 0; i < icons.length; i++ ){

                const activeSVG = icons[ i ].querySelector( 'div' );
                const decimals = getRoundRating( $wrapper ) - Math.floor( $wrapper.getAttribute( 'data-rating' ) );

                // Hide voting results
                if ( secrecy ) {

                    // Hide empty stars id secrecy activated and no rating value
                    if ( !voted ) {
                        activeSVG.style.width = '0';
                        continue;
                    }

                    // Hide empty stars if 'Your rating is' set to hide and no rating value
                    if ( $wrapper.getAttribute( 'data-your-rating' ) === 'hide' && voted ) {
                        activeSVG.style.width = '0';
                        continue;
                    }

                }

                // Fill or empty stars
                activeSVG.style.width = i < getRoundRating( $wrapper ) ? '100%' : '0';

                // Half stars
                if ( decimals !== 0 && i === Math.floor( $wrapper.getAttribute( 'data-rating' ) ) ) { activeSVG.style.width = 100 * decimals + '%'; }

            }

        }

        /**
         * Displays 'Your rating is' text message and rating
         *
         * @param $wrapper - Stellar parent element
         */
        function yourRatingMessage( $wrapper ) {

            if ( $wrapper.getAttribute( 'data-your-rating' ) !== 'text' ) { return; } // Exit if message set to hide
            const thisId = $wrapper.id.replace( 'mdp-stellar-', '' );

            if ( stellarDataLS[ `rating_${ thisId }` ] === undefined ) { return; } // Exit if no votes in Local Storage

            $wrapper.querySelector( '.mdp-stellar-your-rating' ).classList.remove( 'mdp-hidden' );
            $wrapper.querySelector( '.mdp-stellar-your-rating span' ).innerHTML += ' ' + stellarDataLS[ `rating_${ thisId }` ];

        }

        /**
         * Behavior of Stellar regarding to Local Storage and Session Storage
         *
         * @param $wrapper - Stellar parent element
         */
        function stellarBehavior( $wrapper ) {

            const stellarIconBoxes = $wrapper.querySelector( '.mdp-box-icon' );
            const thisId = $wrapper.id.replace( 'mdp-stellar-', '' );

            /** Already has record in Local Storage */
            if( stellarDataLS[ `rating_${ thisId }` ] !== undefined ) {

                if ( stellarDataSS === null ) {

                    /** Add class and message for unable rating */
                    stellarIconBoxes.classList.add( 'mdp-stellar-unable' );
                    stellarIconBoxes.addEventListener( 'click', stellarMessage );

                } else {

                    /** Voted in this session */
                    fNew[ `stellar${ thisId }` ] = 0;
                    stellarEvents( $wrapper );

                }

            } else {

                /** No record in Local Storage */
                stellarEvents( $wrapper );

            }

        }

        /** Run for all Stellar Boxes */
        for ( let i = 0; i < stellarBox.length; i++ ) {

            const $stellarWrapper = stellarBox[ i ]; // Stellar Wrapper

            if ( $stellarWrapper.getAttribute( 'data-your-rating' ) !== 'stars' ) { // Hide user voting result 'hide' and 'text'

                stellarRating( $stellarWrapper );
                yourRatingMessage( $stellarWrapper );
                if ( wpData.session === 'on' ) { stellarBehavior( $stellarWrapper ); } else { stellarEvents( $stellarWrapper ); }

            } else { // Show user voting result as stars

                stellarResults( $stellarWrapper );
                if ( wpData.session === 'on' ) { stellarBehavior( $stellarWrapper ); } else { stellarEvents( $stellarWrapper ); }

            }

        }

        /** When you reload the page, the likes are not erased with the mouse. */
        sessionStorage.setItem( "is_reloaded", true );

        /** Check multiple browser tabs are open */
        const watchTabs = function( event ) {

            /** Identify the event that occurred. */
            if ( event.key === 'mdpLocalStellarData' ) {

                /** Get data from the Local Storage. */
                let stellarDataLS = JSON.parse( window.localStorage.getItem( "mdpLocalStellarData" ) );

                for ( let i = 0; i < stellarBox.length; i++ ) {

                    const $stellarWrapper = stellarBox[ i ];
                    const thisId = $stellarWrapper.id.replace( 'mdp-stellar-', '' );

                    /** We remove the asset class from the icons. */
                    for ( let i = 0; i < stellarDataLS.best_rating; i++ ) {
                        $stellarWrapper.getElementsByTagName( 'i' )[i].classList.remove( 'mdp-stellar-active' );
                    }

                    /** Add an asset class to the icons that have been selected. */
                    for ( let i = 0; i < parseInt( stellarDataLS[ `rating_${ thisId }` ] ); i++ ) {
                        /** Set the flag of the current session. */
                        fNew[ `stellar${ thisId }` ] = 0;

                        $stellarWrapper.getElementsByTagName( 'i' )[i].classList.add( 'mdp-stellar-active' );
                    }

                    const data = {
                        'stellar_id': thisId,
                        'rating': stellarDataLS[ `rating_${ thisId }` ],
                        'length': wpData.length,
                        'new_stellar': fNew[ `stellar${ thisId }` ] && fNew[ `stellar${ thisId }` ] === 0 ? 0 : 1
                    };

                    /** Request Page Rank. */
                    setTimeout( () => {
                        stellarPageRating( data );
                    }, 200 );

                }

            }

        };
        window.addEventListener( 'storage', watchTabs );

    } );

} () );

})();

/******/ })()
;